<!--- create the beans ! --->
<cfset createObject('component','com.falkensweb.aop.FacadeStarter').destroy()>
<cfset createObject('component','com.falkensweb.aop.FacadeStarter').init('./beans.xml')>

<h3>Test the SessionToken CFC</h3>

Service:
<cfset man=createObject('component','com.falkensweb.service.SessionToken')>

get a token
<cfdump var="#man.get()#">
<hr>
Get and check a token
<cfset tok=man.get()>
tok:<cfdump var="#tok#">
check:<cfdump var="#man.check(tok)#">

<hr>
Check invalid token 1 ?
<cftry><cfdump var="#man.check('not a token')#" >
<cfcatch type="com.falkensweb.service.SessionTokenException">
	caught exception <cfdump var="#cfcatch#" expand="false">
</cfcatch>
</cftry>
<hr>
Check invalid token 2 ?
<cftry>
<cfdump var="#man.check(createUUID())#" >
<cfcatch type="com.falkensweb.service.SessionTokenException">
	caught exception <cfdump var="#cfcatch#" expand="false">
</cfcatch>
</cftry>

<hr>
Store string against the token and retrieve it
<cfset tok=man.get('username')>
<cfoutput>#tok#</cfoutput>
<cfdump var="#man.check(tok)#">
<hr>
Store struct against the token and retrieve it
<cfset struct=structNew()>
<cfset struct.something='else'>
<cfset tok=man.get(struct)>
<cfoutput>#tok#</cfoutput>
<cfdump var="#man.check(tok)#">

<hr> 
<h3>AOP advice and remote facade</h3>
<cfset loginserv=createObject('component','com.falkensweb.demo.remote.LoginService')>
<cfset serv=createObject('component','com.falkensweb.demo.remote.ShoppingBasket')>
<cfset tok=loginserv.login('myusername')>
Lokin, token is <cfdump var="#tok.data.sessionToken#">

Demo Service
<cfdump var="#serv.get(tok.data.sessionToken)#">

Demo Service (with error)
<cfdump var="#serv.getWithError(tok.data.sessionToken)#">

Demo Service (invalid token)
<cfdump var="#serv.get('no a token')#">